/* Generated by YAKINDU Statechart Tools for Arduino v0.3.0 */

#include "TWOstates.h"
#include <string.h>
/*! \file Implementation of the state machine 'TWOstates'
*/

TWOstates::TWOstates()
{
	
	
	stateConfVectorPosition = 0;
	
	timer = null;
}

TWOstates::~TWOstates()
{
}


void TWOstates::init()
{
	for (int i = 0; i < maxOrthogonalStates; ++i)
		stateConfVector[i] = TWOstates_last_state;
	
	stateConfVectorPosition = 0;

	clearInEvents();
	clearOutEvents();
	
	/* Default init sequence for statechart TWOstates */
	iface.KAU = 0;
	iface.T = false;
}

void TWOstates::enter()
{
	/* Default enter sequence for statechart TWOstates */
	enseq_main_region_default();
}

void TWOstates::exit()
{
	/* Default exit sequence for statechart TWOstates */
	exseq_main_region();
}

sc_boolean TWOstates::isActive()
{
	return stateConfVector[0] != TWOstates_last_state;
}

/* 
 * Always returns 'false' since this state machine can never become final.
 */
sc_boolean TWOstates::isFinal()
{
   return false;}

void TWOstates::runCycle()
{
	
	clearOutEvents();
	
	for (stateConfVectorPosition = 0;
		stateConfVectorPosition < maxOrthogonalStates;
		stateConfVectorPosition++)
		{
			
		switch (stateConfVector[stateConfVectorPosition])
		{
		case main_region_State10 :
		{
			react_main_region_State10();
			break;
		}
		case main_region_State11_r1_State0 :
		{
			react_main_region_State11_r1_State0();
			break;
		}
		case main_region_State11_r1_State1 :
		{
			react_main_region_State11_r1_State1();
			break;
		}
		default:
			break;
		}
	}
	
	clearInEvents();
}

void TWOstates::clearInEvents()
{
	iface.DCY_raised = false;
	iface.HMIbutton_raised = false;
	timeEvents[0] = false; 
}

void TWOstates::clearOutEvents()
{
}


void TWOstates::setTimer(TimerInterface* timer)
{
	this->timer = timer;
}

TimerInterface* TWOstates::getTimer()
{
	return timer;
}

void TWOstates::raiseTimeEvent(sc_eventid evid)
{
	if ((evid >= &timeEvents) && (evid < &timeEvents + sizeof(timeEvents)))
	{
		*(sc_boolean*)evid = true;
	}
}

sc_boolean TWOstates::isStateActive(TWOstatesStates state)
{
	switch (state)
	{
		case main_region_State10 : 
			return (sc_boolean) (stateConfVector[0] == main_region_State10
			);
		case main_region_State11 : 
			return (sc_boolean) (stateConfVector[0] >= main_region_State11
				&& stateConfVector[0] <= main_region_State11_r1_State1);
		case main_region_State11_r1_State0 : 
			return (sc_boolean) (stateConfVector[0] == main_region_State11_r1_State0
			);
		case main_region_State11_r1_State1 : 
			return (sc_boolean) (stateConfVector[0] == main_region_State11_r1_State1
			);
		default: return false;
	}
}

TWOstates::DefaultSCI* TWOstates::getDefaultSCI()
{
	return &iface;
}

void TWOstates::DefaultSCI::raise_dCY()
{
	DCY_raised = true;
}

void TWOstates::raise_dCY()
{
	iface.raise_dCY();
}

void TWOstates::DefaultSCI::raise_hMIbutton()
{
	HMIbutton_raised = true;
}

void TWOstates::raise_hMIbutton()
{
	iface.raise_hMIbutton();
}


sc_integer TWOstates::DefaultSCI::get_kAU()
{
	return KAU;
}

sc_integer TWOstates::get_kAU()
{
	return iface.KAU;
}

void TWOstates::DefaultSCI::set_kAU(sc_integer value)
{
	KAU = value;
}

void TWOstates::set_kAU(sc_integer value)
{
	iface.KAU = value;
}

sc_boolean TWOstates::DefaultSCI::get_t()
{
	return T;
}

sc_boolean TWOstates::get_t()
{
	return iface.T;
}

void TWOstates::DefaultSCI::set_t(sc_boolean value)
{
	T = value;
}

void TWOstates::set_t(sc_boolean value)
{
	iface.T = value;
}


// implementations of all internal functions

sc_boolean TWOstates::check_main_region_State10_tr0_tr0()
{
	return iface.KAU == 1;
}

sc_boolean TWOstates::check_main_region_State10_lr0_lr0()
{
	return timeEvents[0];
}

sc_boolean TWOstates::check_main_region_State11_tr0_tr0()
{
	return iface.KAU == 0;
}

sc_boolean TWOstates::check_main_region_State11_r1_State0_tr0_tr0()
{
	return iface.DCY_raised || iface.HMIbutton_raised;
}

sc_boolean TWOstates::check_main_region_State11_r1_State0_lr0_lr0()
{
	return true;
}

sc_boolean TWOstates::check_main_region_State11_r1_State1_tr0_tr0()
{
	return iface.DCY_raised || iface.HMIbutton_raised;
}

sc_boolean TWOstates::check_main_region_State11_r1_State1_lr0_lr0()
{
	return true;
}

void TWOstates::effect_main_region_State10_tr0()
{
	exseq_main_region_State10();
	enseq_main_region_State11_default();
}

void TWOstates::effect_main_region_State10_lr0_lr0()
{
	iface.T = false;
}

void TWOstates::effect_main_region_State11_tr0()
{
	exseq_main_region_State11();
	enseq_main_region_State10_default();
}

void TWOstates::effect_main_region_State11_r1_State0_tr0()
{
	exseq_main_region_State11_r1_State0();
	enseq_main_region_State11_r1_State1_default();
}

void TWOstates::effect_main_region_State11_r1_State0_lr0_lr0()
{
	iface.T = false;
}

void TWOstates::effect_main_region_State11_r1_State1_tr0()
{
	exseq_main_region_State11_r1_State1();
	enseq_main_region_State11_r1_State0_default();
}

void TWOstates::effect_main_region_State11_r1_State1_lr0_lr0()
{
	iface.T = true;
}

/* Entry action for state 'State10'. */
void TWOstates::enact_main_region_State10()
{
	/* Entry action for state 'State10'. */
	timer->setTimer(this, &timeEvents[0], 1 / 1000000, false);
}

/* Exit action for state 'State10'. */
void TWOstates::exact_main_region_State10()
{
	/* Exit action for state 'State10'. */
	timer->unsetTimer(this, &timeEvents[0]);
}

/* 'default' enter sequence for state State10 */
void TWOstates::enseq_main_region_State10_default()
{
	/* 'default' enter sequence for state State10 */
	enact_main_region_State10();
	stateConfVector[0] = main_region_State10;
	stateConfVectorPosition = 0;
}

/* 'default' enter sequence for state State11 */
void TWOstates::enseq_main_region_State11_default()
{
	/* 'default' enter sequence for state State11 */
	enseq_main_region_State11_r1_default();
}

/* 'default' enter sequence for state State0 */
void TWOstates::enseq_main_region_State11_r1_State0_default()
{
	/* 'default' enter sequence for state State0 */
	stateConfVector[0] = main_region_State11_r1_State0;
	stateConfVectorPosition = 0;
}

/* 'default' enter sequence for state State1 */
void TWOstates::enseq_main_region_State11_r1_State1_default()
{
	/* 'default' enter sequence for state State1 */
	stateConfVector[0] = main_region_State11_r1_State1;
	stateConfVectorPosition = 0;
}

/* 'default' enter sequence for region main region */
void TWOstates::enseq_main_region_default()
{
	/* 'default' enter sequence for region main region */
	react_main_region__entry_Default();
}

/* 'default' enter sequence for region r1 */
void TWOstates::enseq_main_region_State11_r1_default()
{
	/* 'default' enter sequence for region r1 */
	react_main_region_State11_r1__entry_Default();
}

/* Default exit sequence for state State10 */
void TWOstates::exseq_main_region_State10()
{
	/* Default exit sequence for state State10 */
	stateConfVector[0] = TWOstates_last_state;
	stateConfVectorPosition = 0;
	exact_main_region_State10();
}

/* Default exit sequence for state State11 */
void TWOstates::exseq_main_region_State11()
{
	/* Default exit sequence for state State11 */
	exseq_main_region_State11_r1();
}

/* Default exit sequence for state State0 */
void TWOstates::exseq_main_region_State11_r1_State0()
{
	/* Default exit sequence for state State0 */
	stateConfVector[0] = TWOstates_last_state;
	stateConfVectorPosition = 0;
}

/* Default exit sequence for state State1 */
void TWOstates::exseq_main_region_State11_r1_State1()
{
	/* Default exit sequence for state State1 */
	stateConfVector[0] = TWOstates_last_state;
	stateConfVectorPosition = 0;
}

/* Default exit sequence for region main region */
void TWOstates::exseq_main_region()
{
	/* Default exit sequence for region main region */
	/* Handle exit of all possible states (of TWOstates.main_region) at position 0... */
	switch(stateConfVector[ 0 ])
	{
		case main_region_State10 :
		{
			exseq_main_region_State10();
			break;
		}
		case main_region_State11_r1_State0 :
		{
			exseq_main_region_State11_r1_State0();
			break;
		}
		case main_region_State11_r1_State1 :
		{
			exseq_main_region_State11_r1_State1();
			break;
		}
		default: break;
	}
}

/* Default exit sequence for region r1 */
void TWOstates::exseq_main_region_State11_r1()
{
	/* Default exit sequence for region r1 */
	/* Handle exit of all possible states (of TWOstates.main_region.State11.r1) at position 0... */
	switch(stateConfVector[ 0 ])
	{
		case main_region_State11_r1_State0 :
		{
			exseq_main_region_State11_r1_State0();
			break;
		}
		case main_region_State11_r1_State1 :
		{
			exseq_main_region_State11_r1_State1();
			break;
		}
		default: break;
	}
}

/* The reactions of state State10. */
void TWOstates::react_main_region_State10()
{
	/* The reactions of state State10. */
	if (check_main_region_State10_tr0_tr0())
	{ 
		effect_main_region_State10_tr0();
	}  else
	{
		if (check_main_region_State10_lr0_lr0())
		{ 
			effect_main_region_State10_lr0_lr0();
		} 
	}
}

/* The reactions of state State0. */
void TWOstates::react_main_region_State11_r1_State0()
{
	/* The reactions of state State0. */
	if (check_main_region_State11_tr0_tr0())
	{ 
		effect_main_region_State11_tr0();
	}  else
	{
		if (check_main_region_State11_r1_State0_tr0_tr0())
		{ 
			effect_main_region_State11_r1_State0_tr0();
		}  else
		{
			effect_main_region_State11_r1_State0_lr0_lr0();
		}
	}
}

/* The reactions of state State1. */
void TWOstates::react_main_region_State11_r1_State1()
{
	/* The reactions of state State1. */
	if (check_main_region_State11_tr0_tr0())
	{ 
		effect_main_region_State11_tr0();
	}  else
	{
		if (check_main_region_State11_r1_State1_tr0_tr0())
		{ 
			effect_main_region_State11_r1_State1_tr0();
		}  else
		{
			effect_main_region_State11_r1_State1_lr0_lr0();
		}
	}
}

/* Default react sequence for initial entry  */
void TWOstates::react_main_region__entry_Default()
{
	/* Default react sequence for initial entry  */
	enseq_main_region_State10_default();
}

/* Default react sequence for initial entry  */
void TWOstates::react_main_region_State11_r1__entry_Default()
{
	/* Default react sequence for initial entry  */
	enseq_main_region_State11_r1_State0_default();
}


