/* Generated by YAKINDU Statechart Tools for Arduino v0.3.0 */

#ifndef TWOSTATES_H_
#define TWOSTATES_H_

#include "sc_types.h"
#include "StatemachineInterface.h"
#include "TimedStatemachineInterface.h"

/*! \file Header of the state machine 'TWOstates'.
*/

class TWOstates : public TimedStatemachineInterface, public StatemachineInterface
{
	
	public:
		
		TWOstates();
		
		~TWOstates();
		
		/*! Enumeration of all states */ 
		typedef enum
		{
			main_region_State10,
			main_region_State11,
			main_region_State11_r1_State0,
			main_region_State11_r1_State1,
			TWOstates_last_state
		} TWOstatesStates;
		
		//! Inner class for default interface scope.
		class DefaultSCI
		{
			
			public:
				/*! Gets the value of the variable 'KAU' that is defined in the default interface scope. */
				sc_integer get_kAU();
				
				/*! Sets the value of the variable 'KAU' that is defined in the default interface scope. */
				void set_kAU(sc_integer value);
				
				/*! Raises the in event 'DCY' that is defined in the default interface scope. */
				void raise_dCY();
				
				/*! Raises the in event 'HMIbutton' that is defined in the default interface scope. */
				void raise_hMIbutton();
				
				/*! Gets the value of the variable 'T' that is defined in the default interface scope. */
				sc_boolean get_t();
				
				/*! Sets the value of the variable 'T' that is defined in the default interface scope. */
				void set_t(sc_boolean value);
				
				
			private:
				friend class TWOstates;
				sc_integer KAU;
				sc_boolean DCY_raised;
				sc_boolean HMIbutton_raised;
				sc_boolean T;
		};
				
		
		/*! Returns an instance of the interface class 'DefaultSCI'. */
		DefaultSCI* getDefaultSCI();
		
		/*! Gets the value of the variable 'KAU' that is defined in the default interface scope. */
		sc_integer get_kAU();
		
		/*! Sets the value of the variable 'KAU' that is defined in the default interface scope. */
		void set_kAU(sc_integer value);
		
		/*! Raises the in event 'DCY' that is defined in the default interface scope. */
		void raise_dCY();
		
		/*! Raises the in event 'HMIbutton' that is defined in the default interface scope. */
		void raise_hMIbutton();
		
		/*! Gets the value of the variable 'T' that is defined in the default interface scope. */
		sc_boolean get_t();
		
		/*! Sets the value of the variable 'T' that is defined in the default interface scope. */
		void set_t(sc_boolean value);
		
		
		void init();
		
		void enter();
		
		void exit();
		
		void runCycle();
		
		/*!
		* Checks if the state machine is active (until 2.4.1 this method was used for states).
		* A state machine is active if it has been entered. It is inactive if it has not been entered at all or if it has been exited.
		*/
		sc_boolean isActive();
		
		
		/*!
		* Checks if all active states are final. 
		* If there are no active states then the state machine is considered being inactive. In this case this method returns false.
		*/
		sc_boolean isFinal();
		
		void setTimer(TimerInterface* timer);
		
		TimerInterface* getTimer();
		
		void raiseTimeEvent(sc_eventid event);
		
		/*! Checks if the specified state is active (until 2.4.1 the used method for states was calles isActive()). */
		sc_boolean isStateActive(TWOstatesStates state);
	
	private:
	
	
		//! the maximum number of orthogonal states defines the dimension of the state configuration vector.
		static const sc_integer maxOrthogonalStates = 1;
		
		TimerInterface* timer;
		sc_boolean timeEvents[1];
		
		TWOstatesStates stateConfVector[maxOrthogonalStates];
		
		sc_ushort stateConfVectorPosition;
		
		DefaultSCI iface;
		
		// prototypes of all internal functions
		
		sc_boolean check_main_region_State10_tr0_tr0();
		sc_boolean check_main_region_State10_lr0_lr0();
		sc_boolean check_main_region_State11_tr0_tr0();
		sc_boolean check_main_region_State11_r1_State0_tr0_tr0();
		sc_boolean check_main_region_State11_r1_State0_lr0_lr0();
		sc_boolean check_main_region_State11_r1_State1_tr0_tr0();
		sc_boolean check_main_region_State11_r1_State1_lr0_lr0();
		void effect_main_region_State10_tr0();
		void effect_main_region_State10_lr0_lr0();
		void effect_main_region_State11_tr0();
		void effect_main_region_State11_r1_State0_tr0();
		void effect_main_region_State11_r1_State0_lr0_lr0();
		void effect_main_region_State11_r1_State1_tr0();
		void effect_main_region_State11_r1_State1_lr0_lr0();
		void enact_main_region_State10();
		void exact_main_region_State10();
		void enseq_main_region_State10_default();
		void enseq_main_region_State11_default();
		void enseq_main_region_State11_r1_State0_default();
		void enseq_main_region_State11_r1_State1_default();
		void enseq_main_region_default();
		void enseq_main_region_State11_r1_default();
		void exseq_main_region_State10();
		void exseq_main_region_State11();
		void exseq_main_region_State11_r1_State0();
		void exseq_main_region_State11_r1_State1();
		void exseq_main_region();
		void exseq_main_region_State11_r1();
		void react_main_region_State10();
		void react_main_region_State11_r1_State0();
		void react_main_region_State11_r1_State1();
		void react_main_region__entry_Default();
		void react_main_region_State11_r1__entry_Default();
		void clearInEvents();
		void clearOutEvents();
		
};
#endif /* TWOSTATES_H_ */
